`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:  Dioo 
// Engineer: Joe
// 
// Create Date: 2023-3-5   
// Design Name: dio36812    
// Module Name: dio36812_digital_top   
// Description: 350ms or 450ms
//
// Dependencies: 
//
// Revision: 240325
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

module dio36812_dig_top(
    input                  CLK                 ,
    input                  POR_RST             ,
    input                  I2C_EN_DIG          ,
    input                  A_DE0_SCL_DIG       ,
    input                  A_EQ1_SDA_DIG       ,

    input                  A_HS_EN_BUF         ,
    input                  A_POLLING           ,
    input                  A_DATA_ENV_OUT      ,
    input                  A_LS_EN             ,
    input                  A_TX_CMP            ,

    input                  A_EQ0_NC_DIG        ,  //add
    input                  A_DE1_NC_DIG        ,  //add

    output                 A_CM_CTLB           ,
    output                 A_RX_DET_CTL        ,
    output                 A_RX_GAIN_OFF       ,
    output                 A_RTERM_CMP_OFF     ,
    output                 A_RTERM_DETB        ,
    
    input                  B_HS_EN_BUF         ,
    input                  B_POLLING           ,
    input                  B_DATA_ENV_OUT      ,
    input                  B_LS_EN             ,
    input                  B_TX_CMP            ,
    
    input                  B_DE0_I2C_A0_DIG    ,  //add
    input                  B_DE1_NC_DIG        ,  //add
    input                  B_EQ0_NC_DIG        ,  //add
    input                  B_EQ1_I2C_A1_DIG    ,  //add

    output                 B_CM_CTLB           ,
    output                 B_RX_DET_CTL        ,
    output                 B_RX_GAIN_OFF       ,
    output                 B_RTERM_CMP_OFF     ,
    output                 B_RTERM_DETB        ,


    output                 RTERM_DETB          ,

    output                 SDA_OUT             ,

    output                 U2_EN               ,
    output                 LP_EN               ,
    output  [3:0]          A_C0                ,
    output  [3:0]          A_C1                ,
    output  [3:0]          A_R0                ,
    output  [3:0]          A_R1                ,
    output  [3:0]          A_DE                ,

    output  [3:0]          B_C0                ,
    output  [3:0]          B_C1                ,
    output  [3:0]          B_R0                ,
    output  [3:0]          B_R1                ,
    output  [3:0]          B_DE                ,

    output                 OSC_FAST            ,
    output                 OSC_SLOW            ,
    output  [1:0]          LDO_CTL             ,
    output  [1:0]          VOD_CTL             ,
    output  [1:0]          TX_RTERM_CTL        , 
    output  [1:0]          RX_RTERM_CTL        ,
    output  [3:0]          LFPS_LVL            ,
    output  [2:0]          CFG_LOS_VTH         ,
   
    output  [2:0]          IBIAS_CTL_UP        ,
    output  [2:0]          IBIAS_CTL_DW        ,
    output                 I2C_VTH_SWITCH      ,
    output                 I2C_EN_IO           ,

    output                 U2_EN_TEST          ,
    output                 A_RX_DET_CTL_TEST   ,
    output                 A_RTERM_CMP_OFF_TEST,
    output                 B_RX_DET_CTL_TEST   ,
    output                 B_RTERM_CMP_OFF_TEST,
    output                 LP_EN_TEST          ,
    
    output                 A_POLLING_TEST      ,
    output                 A_DATA_ENV_OUT_TEST ,
    output                 A_TX_CTL_TEST       ,
    output                 A_HS_EN_TEST        ,
    output                 A_LS_EN_TEST        ,
    output                 A_RX_GAIN_OFF_TEST  ,
    output                 A_TX_CMP_TEST       ,
    output                 A_RTERM_DETB_TEST   ,

    output                 B_POLLING_TEST      ,
    output                 B_DATA_ENV_OUT_TEST ,
    output                 B_TX_CTL_TEST       ,
    output                 B_HS_EN_TEST        ,
    output                 B_LS_EN_TEST        ,
    output                 B_RX_GAIN_OFF_TEST  ,
    output                 B_TX_CMP_TEST       ,
    output                 B_RTERM_DETB_TEST   ,
    
    output                 PU_CTL              , 
    output                 LP_EN_CTL           ,

    output [1:0]           DATA_EN_CTL         ,	
    output [1:0]           LS_EN_CTL           ,
    output                 DE_LFPS_CTL         ,
    output                 LS_DLY_MAX          ,
    output                 LS_DLY_MIN          ,


    output                 A_VDDL_CTL          ,
    output                 B_VDDL_CTL          ,
    output                 A_LANE_CTL          ,
    output                 B_LANE_CTL          ,

    output                 DET_MOD             ,
    output                 RX_GAIN_OFF         ,
    output                 TST_A_EN            ,
    output                 TST_B_EN            ,
    output                 TST_C_EN           
    );



//`define SIMANA

//i2c reg

wire    [3:0]          rx_det_ctl_sel      ;


wire                    LATCH_SLP_S0       ;

//sig_mux

wire    [3:0]          io_a_c0   ;
wire    [3:0]          io_a_c1   ;
wire    [3:0]          io_a_r0   ;
wire    [3:0]          io_a_r1   ;
wire    [3:0]          io_a_de   ;
wire    [3:0]          io_b_c0   ;
wire    [3:0]          io_b_c1   ;
wire    [3:0]          io_b_r0   ;
wire    [3:0]          io_b_r1   ;
wire    [3:0]          io_b_de   ;
wire    [3:0]          i2c_a_c0  ;
wire    [3:0]          i2c_a_c1  ;
wire    [3:0]          i2c_a_r0  ;
wire    [3:0]          i2c_a_r1  ;
wire    [3:0]          i2c_a_de  ;
wire    [3:0]          i2c_b_c0  ;
wire    [3:0]          i2c_b_c1  ;
wire    [3:0]          i2c_b_r0  ;
wire    [3:0]          i2c_b_r1  ;
wire    [3:0]          i2c_b_de  ;

wire                   i2c_sda_in;
wire                   i2c_scl   ;


wire   [7:0]           i2c_dev_addr;
wire   [7:0]           i2c_addr;
wire   [7:0]           i2c_datain;
wire   [7:0]           i2c_dataout;
wire                   i2c_write;

wire                   i2c_a1;
wire                   i2c_a0;

wire   [2:0]           cm_ctlb_ctl;

wire                   i2c_sda_f;
wire                   i2c_scl_f;

wire   [3:0]           det_ctl_sel;

wire                   rx_det_ctl_10u ;
wire                   rx_det_ctl_80u ;
wire                   rx_det_ctl_40u ;
wire                   rx_det_ctl_20u ;
wire                   rx_det_ctl_2u  ;

reg                    rterm_cmp_off_n;
wire                   rterm_cmp_off_tmp;
reg                    rx_det_ctl_tmp; 
wire                   rx_det_en;
wire                   reg_en;
wire                   io_rstn;
wire                   rstn;

wire   [4:0]           VCM_CTL;         

wire pulse_cnt_10;
wire pulse_cnt_1 ;
wire pulse_cnt_2 ;
wire pulse_cnt_3 ;
reg  add_cmp_end ;
reg  add_det_check;
reg  add_a_check_result;
reg  add_b_check_result;
wire add_a_f_result;
wire add_b_f_result;
wire add_rterm_cmp_off;
wire add_rxdet_ctl;
wire data_env_en;

wire a_rterm_cmp_off_r;
wire b_rterm_cmp_off_r;


wire d240ms_disable;      
reg  nolfps_4ms_en;
wire nolfps_4ms_disable;
wire rterm_detb_enter_u0_en;
reg  nolfps_4ms_disable_r;

wire a_r_b0;
wire b_r_b0;

reg [1:0] data_env_r;
wire      rterm_detb_n;


wire det_ctl0;
wire det_ctl1;
wire det_ctl2;
wire det_ctl3;
wire det_ctl4;
wire det_ctl5;
wire det_ctl6;

wire [12:0] txpulse_cnt;


wire u2_rxdet_en_1;
wire u2_rxdet_en_2;
wire u2_rxdet_en;
wire tx_cmp_s;

wire pulse_350450_syn;

wire l1_lfps_det;    
wire lfps_det_3cycle_1;

wire [3:0]  lfps_det_dly;
wire        txpulse_cnt_b10;

wire        usb_rterm_cmp_off;



`ifdef SIMANA
    assign txpulse_cnt_b10 = txpulse_cnt[1];
`else
    assign txpulse_cnt_b10 = txpulse_cnt[10];
`endif




spare_top  
spare_top(
    .u2_en(U2_EN),
    .txpulse_cnt_b10(txpulse_cnt_b10),
    .u2_rxdet_en(u2_rxdet_en)
);



assign rterm_detb_n = ~RTERM_DETB;


always @(posedge CLK or negedge rstn)
begin
    if(!rstn) data_env_r <= 2'b00;
    else      data_env_r <= {data_env_r[0],(A_DATA_ENV_OUT | B_DATA_ENV_OUT)};
end

assign TST_A_EN = I2C_EN_DIG & (A_POLLING_TEST | A_DATA_ENV_OUT_TEST | A_TX_CTL_TEST | A_HS_EN_TEST | A_LS_EN_TEST | A_RX_GAIN_OFF_TEST | A_TX_CMP_TEST | A_RTERM_DETB_TEST);  

assign TST_B_EN = I2C_EN_DIG & (A_RX_DET_CTL_TEST | A_RTERM_CMP_OFF_TEST | B_RX_DET_CTL_TEST | B_RTERM_CMP_OFF_TEST | U2_EN_TEST | LP_EN_TEST); 

assign TST_C_EN = I2C_EN_DIG & (B_POLLING_TEST | B_DATA_ENV_OUT_TEST | B_TX_CTL_TEST | B_HS_EN_TEST | B_LS_EN_TEST | B_RX_GAIN_OFF_TEST | B_TX_CMP_TEST | B_RTERM_DETB_TEST); 


assign RTERM_DETB = A_RTERM_DETB | B_RTERM_DETB;

assign I2C_EN_IO = ~I2C_EN_DIG;

assign i2c_sda_in = (~I2C_EN_DIG ) | A_EQ1_SDA_DIG;
assign i2c_scl    = (~I2C_EN_DIG ) | A_DE0_SCL_DIG;


assign i2c_a0 = I2C_EN_DIG & B_DE0_I2C_A0_DIG;
assign i2c_a1 = I2C_EN_DIG & B_EQ1_I2C_A1_DIG;


assign rterm_cmp_off_tmp = ~((~(~(rterm_cmp_off_n & (~U2_EN)))) | (~(~(rterm_cmp_off_n & rx_det_en))));   //eco


assign usb_rterm_cmp_off = ~(~(rterm_cmp_off_tmp & add_rterm_cmp_off));

/*

always @(posedge CLK or negedge rstn)
begin
	if(!rstn)
	begin
		a_rterm_cmp_off_r <= 1'b1;
		b_rterm_cmp_off_r <= 1'b1;
	end
	else
	begin
		a_rterm_cmp_off_r <= (~(~(rterm_cmp_off_tmp & add_rterm_cmp_off)));// | (~A_RX_GAIN_OFF);    //(u_usb_rxtx_1.u_usb_lanctl_1.power_mode == 2'b01);
		b_rterm_cmp_off_r <= (~(~(rterm_cmp_off_tmp & add_rterm_cmp_off)));// | (~B_RX_GAIN_OFF);    //(u_usb_rxtx_1.u_usb_lanctl_1.power_mode == 2'b01);

	end
end
*/



assign A_RTERM_CMP_OFF = a_rterm_cmp_off_r | (~A_RX_GAIN_OFF);
assign B_RTERM_CMP_OFF = b_rterm_cmp_off_r | (~B_RX_GAIN_OFF);

assign A_RX_DET_CTL = (~(~((rx_det_ctl_tmp & (~U2_EN)) | (rx_det_ctl_tmp & rx_det_en) | add_rxdet_ctl))) & A_RX_GAIN_OFF & rstn;//(~(u_usb_rxtx_1.u_usb_lanctl_1.power_mode == 2'b01));
assign B_RX_DET_CTL = (~(~((rx_det_ctl_tmp & (~U2_EN)) | (rx_det_ctl_tmp & rx_det_en) | add_rxdet_ctl))) & B_RX_GAIN_OFF & rstn;//(~(u_usb_rxtx_1.u_usb_lanctl_1.power_mode == 2'b01));

assign det_ctl_sel = rx_det_ctl_sel;//u_i2c_reg.RX_DET_CTL_SEL;
assign rx_det_ctl_80u  =  det_ctl1;
assign rx_det_ctl_40u   = det_ctl3;
assign rx_det_ctl_20u   = det_ctl4;
assign rx_det_ctl_10u   = det_ctl5;
assign rx_det_ctl_2u    = det_ctl6;

assign rx_det_en = u2_rxdet_en;  //u2_rxdet_en_1;




`ifdef SIMANA
assign pulse_cnt_3  = txpulse_cnt[2];
assign pulse_cnt_1  = txpulse_cnt[0];
assign pulse_cnt_2  = txpulse_cnt[1];

`else
assign pulse_cnt_3  = txpulse_cnt[4];
assign pulse_cnt_1  = txpulse_cnt[2];
assign pulse_cnt_2  = txpulse_cnt[3];
`endif


//assign u_usb_rxtx_1.u_usb_lanctl_1.u2_nocmpdet = ~(~(u_usb_rxtx_1.u_usb_lanctl_1.u2_nocmpdet_tmp | add_a_f_result));  //will be remove
//assign u_usb_rxtx_1.u_usb_lanctl_2.u2_nocmpdet = ~(~(u_usb_rxtx_1.u_usb_lanctl_2.u2_nocmpdet_tmp | add_b_f_result));  //will be remove

always @(posedge pulse_cnt_3 or negedge rx_det_en)
begin
	if(!rx_det_en)   add_det_check <= 0;
	else             add_det_check <= 1;
end


always @(posedge add_rxdet_ctl or negedge A_TX_CMP)   
begin
	if(!A_TX_CMP)   add_a_check_result <= 0;
	else            add_a_check_result <= 1;
end



always @(posedge add_rxdet_ctl or negedge tx_cmp_s)
begin
	if(!tx_cmp_s)   add_b_check_result <= 0;
	else                         add_b_check_result <= 1;
end


assign add_a_f_result = ~(~(add_a_check_result & add_det_check));//

assign add_b_f_result = ~(~(add_b_check_result & add_det_check));//


always @(posedge pulse_cnt_2 or negedge rx_det_en)
begin
	if(!rx_det_en)   add_cmp_end <= 0;
	else             add_cmp_end <= 1;
end




assign add_rterm_cmp_off = ~(rx_det_en & (~add_cmp_end));


`ifdef SIMANA

assign add_rxdet_ctl = ~(~((~add_rterm_cmp_off) & (~pulse_cnt_2)));

`else
assign add_rxdet_ctl = ~(~((~add_rterm_cmp_off) & (pulse_cnt_1)));
`endif

always @(*)
begin
	case(det_ctl_sel)
		4'b0000:rterm_cmp_off_n = rx_det_ctl_40u ;
		4'b0001:rterm_cmp_off_n = rx_det_ctl_80u ;
	        4'b0010:rterm_cmp_off_n = rx_det_ctl_20u ;
		4'b0011:rterm_cmp_off_n = rx_det_ctl_80u ;
                default:rterm_cmp_off_n = rx_det_ctl_40u ;	
	endcase
end


always @(*)
begin
	case(det_ctl_sel)
		4'b0000:rx_det_ctl_tmp = ~(~(rx_det_ctl_40u & (~rx_det_ctl_20u)));
		4'b0001:rx_det_ctl_tmp = ~(~(rx_det_ctl_80u & (~rx_det_ctl_40u)));
	        4'b0010:rx_det_ctl_tmp = ~(~(rx_det_ctl_20u  & (~rx_det_ctl_10u)));
		4'b0011:rx_det_ctl_tmp = ~(~(rx_det_ctl_80u & (~rx_det_ctl_40u)));
                default:rx_det_ctl_tmp = ~(~(rx_det_ctl_40u  & (~rx_det_ctl_20u)));		
	endcase
end


assign io_rstn = ~(~(rstn & ~(I2C_EN_DIG & (~reg_en))));



wire clk_div16;


i2c_addr_ctl
u_i2c_addr(
    .i2c_a1  (i2c_a1        ),
    .i2c_a0  (i2c_a0        ),
    .addr    (i2c_dev_addr  )
    );




i2c u_i2c(
    .SCL           (i2c_scl               ),
    .SDA           (i2c_sda_in            ),
    .en            (I2C_EN_DIG            ),
    .rstn          (rstn                  ),
    .clk           (CLK                   ),
    .output_control(SDA_OUT               ),
    .device_address(i2c_dev_addr[7:1]     ),
    .input_shift   (i2c_datain            ),
    .write_strobe  (i2c_write             ),
    .index_pointer (i2c_addr              ),
    .read_data     (i2c_dataout           )
);



io_ctl
u_io_ctl(
    .clk      (clk_div6           ),
    .rst_n    (io_rstn            ),
    .a_eq0    (A_EQ0_NC_DIG       ),
    .a_eq1    (A_EQ1_SDA_DIG      ),
    .a_de0    (A_DE0_SCL_DIG      ),
    .a_de1    (A_DE1_NC_DIG       ),  
    .b_eq0    (B_EQ0_NC_DIG       ),
    .b_eq1    (B_EQ1_I2C_A1_DIG   ),
    .b_de0    (B_DE0_I2C_A0_DIG   ),
    .b_de1    (B_DE1_NC_DIG       ),
    .a_c0     (io_a_c0            ),
    .a_c1     (io_a_c1            ),
    .a_r0     (io_a_r0            ),
    .a_r1     (io_a_r1            ),
    .a_de     (io_a_de            ),
    .b_c0     (io_b_c0            ),
    .b_c1     (io_b_c1            ),
    .b_r0     (io_b_r0            ),
    .b_r1     (io_b_r1            ),
    .b_de     (io_b_de            ) 
    );


assign a_r_b0 = io_a_r0[0] & (~(A_EQ1_SDA_DIG & (~A_EQ0_NC_DIG)));
assign b_r_b0 = io_b_r0[0] & (~(B_EQ1_I2C_A1_DIG & (~B_EQ0_NC_DIG)));


sig_mux
u_sig_mux(
    .sel       ((I2C_EN_DIG & reg_en) ),
    .io_a_c0   (io_a_c0    ),
    .io_a_c1   (io_a_c1    ),
    .io_a_r0   (io_a_r0    ),//({io_a_r0[3:2], 1'b0, a_r_b0}),//
    .io_a_r1   (io_a_r1    ),//({io_a_r1[3:2], 1'b0, a_r_b0}),//
    .io_a_de   (io_a_de    ),
    .io_b_c0   (io_b_c0    ),
    .io_b_c1   (io_b_c1    ),
    .io_b_r0   (io_b_r0    ),//({io_b_r0[3:2], 1'b0, b_r_b0}),//
    .io_b_r1   (io_b_r1    ),//({io_b_r1[3:2], 1'b0, b_r_b0}),//
    .io_b_de   (io_b_de    ),
                          
    .i2c_a_c0  (i2c_a_c0   ),
    .i2c_a_c1  (i2c_a_c1   ),
    .i2c_a_r0  (i2c_a_r0   ),
    .i2c_a_r1  (i2c_a_r1   ),
    .i2c_a_de  (i2c_a_de   ),
    .i2c_b_c0  (i2c_b_c0   ),
    .i2c_b_c1  (i2c_b_c1   ),
    .i2c_b_r0  (i2c_b_r0   ),
    .i2c_b_r1  (i2c_b_r1   ),
    .i2c_b_de  (i2c_b_de   ),

    .a_c0      (A_C0       ),
    .a_c1      (A_C1       ),
    .a_r0      (A_R0       ),
    .a_r1      (A_R1       ),
    .a_de      (A_DE       ),
    .b_c0      (B_C0       ),
    .b_c1      (B_C1       ),
    .b_r0      (B_R0       ),
    .b_r1      (B_R1       ),
    .b_de      (B_DE       )
);




clk_rst u_clk_rst (
    .CLK_H       (CLK         ),
    .POR_RST     (POR_RST     ),
    .FUSE_RST    (1'b0        ),
    .clk         (clk_5M      ),
    .clk_div16   (clk_div16   ),
    .clk_div6    (clk_div6    ),
    .rstn        (rstn        )
    );



// I2C Registers
i2c_reg u_i2c_reg(
    .clk                 (i2c_scl                     ),
    .rstn                (rstn                        ),
    .clk_10m             (CLK                         ),
	.l1_lfps_det         (l1_lfps_det                 ),
    .lfps_det_dly        (lfps_det_dly                ),
	//.l1_lfps_det_d3      (lfps_det_3cycle_1           ),
    
    .addr                (i2c_addr                    ),
    .write               (i2c_write                   ),
    .datain              (i2c_datain                  ),
    .dataout             (i2c_dataout                 ),
    
    .A_POLLING           (A_POLLING_TEST              ),
    .B_POLLING           (B_POLLING_TEST              ),
    
    .A_DATAA_ENV_OUT     (A_DATA_ENV_OUT_TEST         ),
    .B_DATAB_ENV_OUT     (B_DATA_ENV_OUT_TEST         ),
    
    .A_TX_CTL            (A_TX_CTL_TEST               ),
    .B_TX_CTL            (B_TX_CTL_TEST               ),
    
    .A_HS_EN             (A_HS_EN_TEST                ),
    .B_HS_EN             (B_HS_EN_TEST                ),
    
    .A_LS_EN             (A_LS_EN_TEST                ),
    .B_LS_EN             (B_LS_EN_TEST                ),
    
    .A_RX_GAIN_OFF       (A_RX_GAIN_OFF_TEST          ),
    .B_RX_GAIN_OFF       (B_RX_GAIN_OFF_TEST          ),
    
    .A_TX_CMP            (A_TX_CMP_TEST               ),
    .B_TX_CMP            (B_TX_CMP_TEST               ),
    
    .A_RTERM_DETB        (A_RTERM_DETB_TEST           ),
    .B_RTERM_DETB        (B_RTERM_DETB_TEST           ),
    
    .U2_EN               (U2_EN_TEST                  ),
    .A_RX_DET_CTL        (A_RX_DET_CTL_TEST           ),
    .A_RTERM_CMP_OFF     (A_RTERM_CMP_OFF_TEST        ),
    .B_RX_DET_CTL        (B_RX_DET_CTL_TEST           ),
    .B_RTERM_CMP_OFF     (B_RTERM_CMP_OFF_TEST        ),
    .LP_EN               (LP_EN_TEST                  ),
    .DET_MOD             (DET_MOD                     ),
    .I2C_VTH_SWITCH      (I2C_VTH_SWITCH              ),
    
    .A_C1                (i2c_a_c1                    ),
    .A_C0                (i2c_a_c0                    ),
    
    .A_R1                (i2c_a_r1                    ),
    .A_R0                (i2c_a_r0                    ),
    
    .B_C1                (i2c_b_c1                    ),
    .B_C0                (i2c_b_c0                    ),
                         
    .B_R1                (i2c_b_r1                    ),
    .B_R0                (i2c_b_r0                    ),
    
    .LDO_CTL             (LDO_CTL                     ),
    .OSC_FAST            (OSC_FAST                    ),
    .OSC_SLOW            (OSC_SLOW                    ),
    .VOD_CTL             (VOD_CTL                     ),
    
    .TX_RTERM_CTL        (TX_RTERM_CTL                ),
    .RX_RTERM_CTL        (RX_RTERM_CTL                ),
    .RX_DET_CTL_SEL      (rx_det_ctl_sel              ),

    .LFPS_LVL            (LFPS_LVL                    ),
    .CFG_LOS_VTH         (CFG_LOS_VTH                 ),
    
    .B_DE                (i2c_b_de                    ),
    .A_DE                (i2c_a_de                    ),
    
    .PU_CTL              (PU_CTL                      ),   
    .LP_EN_CTL           (LP_EN_CTL                   ),

    .DATA_EN_CTL         (DATA_EN_CTL                 ),
    .LS_EN_CTL           (LS_EN_CTL                   ),
    .DE_LFPS_CTL         (DE_LFPS_CTL                 ),
    .LS_DLY_MAX          (LS_DLY_MAX                  ),
    .LS_DLY_MIN          (LS_DLY_MIN                  ),
    .CM_CTLB_CTL         (cm_ctlb_ctl                 ),
    .VCM_CTL             (VCM_CTL                     ),
    .reg_en              (reg_en                      ),
    .data_env_en         (data_env_en                 ),
    .d240ms_disable            (d240ms_disable          ),
    .nolfps_4ms_disable        (nolfps_4ms_disable      ),
    .rterm_detb_enter_u0_en    (rterm_detb_enter_u0_en  ),
    .IBIAS_CTL_UP        (IBIAS_CTL_UP                ),
    .IBIAS_CTL_DW        (IBIAS_CTL_DW                )
);

always @(posedge CLK or negedge rstn)
begin
    if(!rstn)
        nolfps_4ms_disable_r <= 1;
    else
        nolfps_4ms_disable_r <= nolfps_4ms_disable;
end

//assign nolfps_4ms_en = ~nolfps_4ms_disable_r;

//always @(posedge data_env_r[1] or negedge rterm_detb_n) 
//



assign PD1 = 0;
assign usb12_en = 1'b1;
assign LATCH_SLP_S0 = 1'b1;



// USB Channel 1 and Channel 2
usb_rxtx u_usb_rxtx_1 (
    .clk                       (CLK                ),
    .clk_div16                 (clk_div16          ),
    .clk_div6                  (clk_div6           ),
    .rstn                      (rstn               ),
    .usb_rterm_cmp_off         (usb_rterm_cmp_off  ),
    .add_a_f_result            (add_a_f_result     ),    
    .add_b_f_result            (add_b_f_result     ),
    .sel_350_450               (nolfps_4ms_disable ),
    .powerdown                 (PD1                ),
    .cm_ctlb_ctl               (cm_ctlb_ctl        ),
    .SLP_S0                    (LATCH_SLP_S0       ),
    .rx_det_ctl_sel            (rx_det_ctl_sel     ),
    .det_mod                   (DET_MOD            ),
    .data_env_en               (data_env_en        ),
    .d240ms_disable            (d240ms_disable          ),
    //.nolfps_4ms_en             (nolfps_4ms_en           ),
    .rterm_detb_enter_u0_en    (rterm_detb_enter_u0_en  ),

    .i2c_rxdet_period          (2'b00              ),
    .i2c_u2_rxdet_interval     (1'b0               ),
    .i2c_u2_period             (2'b00              ),
    .u2_disable_rxdet          (1'b0               ),
    .lfps_debounce_en          (1'b0               ),
    .l1_lfps_det               (l1_lfps_det        ),
    .lfps_det_dly              (lfps_det_dly       ),
    //.lfps_det_3cycle_1         (lfps_det_3cycle_1  ),
    .lfps_det_3cycle_2         (lfps_det_3cycle_2  ),
    .cm_active                 (cm_active1         ),
    
    .Polling_1                 (A_POLLING          ),
    .U2_EN                     (U2_EN              ),
    .U2_EN_1                   (                   ),
    .U2_EN_2                   (                   ),
    .DATA_ENV_OUT_1            (A_DATA_ENV_OUT     ),
    .HS_EN_1                   (A_HS_EN_BUF        ),
    .LS_EN_1                   (A_LS_EN            ),
    .TX_CMP_1                  (A_TX_CMP           ),
    
    .Polling_2                 (B_POLLING          ),
    .DATA_ENV_OUT_2            (B_DATA_ENV_OUT     ),
    .HS_EN_2                   (B_HS_EN_BUF        ),
    .LS_EN_2                   (B_LS_EN            ),
    .TX_CMP_2                  (B_TX_CMP           ),
    
    .usb_en                    (usb12_en           ),
    
    .lane1                     (A_LANE_CTL         ),
    .lane2                     (B_LANE_CTL         ),
    .lane12                    (                   ),
    .LP_EN                     (LP_EN              ),
    .LP_EN_1                   (                   ),
    .LP_EN_2                   (                   ),
    
    .RX_GAIN_OFF               (RX_GAIN_OFF        ), 

    .CM_CTLB_1                 (A_CM_CTLB          ),
    .vddl_ctl_1                (A_VDDL_CTL),
    .RX_DET_CTL_1              (),// (rterm_cmp_off_n    ),//(A_RX_DET_CTL       ),
    .RTERM_CMP_OFF_1           (a_rterm_cmp_off_r  ),//(A_RTERM_CMP_OFF    ),
    .RX_GAIN_OFF_1             (A_RX_GAIN_OFF      ),
    .RTERM_DETB_1              (A_RTERM_DETB       ),
    .RTERM_DETB_BUF_1          (A_RTERM_DETB_BUF   ),

    .HS_EN_BUF_1               (    ),
    .HS_EN_BUF_2               (    ),
    .CM_CTLB_2                 (B_CM_CTLB          ),
    .vddl_ctl_2                (B_VDDL_CTL         ),
    .RX_DET_CTL_2              (),//(B_RX_DET_CTL       ),
    .RTERM_CMP_OFF_2           (b_rterm_cmp_off_r  ),//(B_RTERM_CMP_OFF    ),
    .RX_GAIN_OFF_2             (B_RX_GAIN_OFF      ),
    .RTERM_DETB_2              (B_RTERM_DETB       ),
    .RTERM_DETB_BUF_2          (B_RTERM_DETB_BUF   ),
    //.pulse_350_syn             (pulse_350_syn      ),
    .tx_cmp_s      (tx_cmp_s       ),
    .u2_rxdet_en   (u2_rxdet_en    ),
    .u2_rxdet_en_1 (u2_rxdet_en_1  ),    
    .u2_rxdet_en_2 (u2_rxdet_en_2  ),
    .txpulse_cnt(txpulse_cnt),
    .pulse_350450_syn(pulse_350450_syn),
    .det_ctl0(det_ctl0 ),
    .det_ctl1(det_ctl1 ),
    .det_ctl2(det_ctl2 ),
    .det_ctl3(det_ctl3 ),
    .det_ctl4(det_ctl4 ),
    .det_ctl5(det_ctl5 ),
    .det_ctl6(det_ctl6 )



    

);








endmodule 
