module io_ctl(
    input                           clk             ,
    input                           rst_n           ,
    input                           a_eq0           ,
    input                           a_eq1           ,
    input                           a_de0           ,
    input                           a_de1           ,
        
    input                           b_eq0           ,
    input                           b_eq1           ,
    input                           b_de0           ,
    input                           b_de1           ,
     
    output  reg      [3:0]          a_c0            ,
    output  reg      [3:0]          a_c1            ,
    output  reg      [3:0]          a_r0            ,
    output  reg      [3:0]          a_r1            ,
    output  reg      [3:0]          a_de            ,

    output  reg      [3:0]          b_c0            ,
    output  reg      [3:0]          b_c1            ,
    output  reg      [3:0]          b_r0            ,
    output  reg      [3:0]          b_r1            ,
    output  reg      [3:0]          b_de             
    );

    wire   [1:0]         a_eq     ;
    wire   [1:0]         b_eq     ;
    
    assign a_eq = {a_eq1,a_eq0};
    assign b_eq = {b_eq1,b_eq0};
    

    always@(*)
    begin
	if(!rst_n)
	begin
	    a_c0 = 4'b0000;
	    a_c1 = 4'b0001;
	    a_r0 = 4'b0101;
	    a_r1 = 4'b0100;
	end
	else
	begin
	    case(a_eq)
		2'b00:begin
		    a_c0 = 4'b0000;
		    a_c1 = 4'b0001;
		    a_r0 = 4'b0101;
		    a_r1 = 4'b0100;
	        end
	        2'b01:begin
		    a_c0 = 4'b0001;
		    a_c1 = 4'b0000;
		    a_r0 = 4'b0100;
		    a_r1 = 4'b0011; 
		end
		2'b10:begin
		    a_c0 = 4'b0000;
		    a_c1 = 4'b0011;
		    a_r0 = 4'b0100;//4'b0101;
		    a_r1 = 4'b0011;//4'b0000;
		end
		2'b11:begin
		    a_c0 = 4'b0000;//4'b0001;
		    a_c1 = 4'b0100;//4'b0010;
		    a_r0 = 4'b0100;//4'b1111;
		    a_r1 = 4'b0100;//4'b0010;//4'b0000;
		end
	    endcase
	end
    end


    always@(*)
    begin
	if(!rst_n)
	begin
	    b_c0 = 4'b0000;
	    b_c1 = 4'b0001;
	    b_r0 = 4'b0101;
	    b_r1 = 4'b0100;
	end
	else
	begin
	    case(b_eq)
		2'b00:begin
		    b_c0 = 4'b0000;
		    b_c1 = 4'b0001;
		    b_r0 = 4'b0101;
		    b_r1 = 4'b0100;
	        end
	        2'b01:begin
		    b_c0 = 4'b0001;
		    b_c1 = 4'b0000;
		    b_r0 = 4'b0100;
		    b_r1 = 4'b0011; 
		end
		2'b10:begin
		    b_c0 = 4'b0000;
		    b_c1 = 4'b0011;
		    b_r0 = 4'b0100;//4'b0101;
		    b_r1 = 4'b0011;//4'b0000;
		end
		2'b11:begin
		    b_c0 = 4'b0000;
		    b_c1 = 4'b0100;//4'b0010;
		    b_r0 = 4'b0100;//4'b1111;
		    b_r1 = 4'b0100;//4'b0010;//4'b0000;
		end
	    endcase
	end
    end

    
    always@(posedge clk or negedge rst_n)
    begin
	if(!rst_n)
	    a_de <= 4'b0000;
	else
            a_de <= {2'b00,a_de1,a_de0};
    end

   
    always@(posedge clk or negedge rst_n)
    begin
	if(!rst_n)
	    b_de <= 4'b0000;
	else
            b_de <= {2'b00,b_de1,b_de0};
    end

endmodule
