
module sig_mux(
    input                  sel                 ,
    input   [3:0]          io_a_c0             ,
    input   [3:0]          io_a_c1             ,
    input   [3:0]          io_a_r0             ,
    input   [3:0]          io_a_r1             ,
    input   [3:0]          io_a_de             ,
    input   [3:0]          io_b_c0             ,
    input   [3:0]          io_b_c1             ,
    input   [3:0]          io_b_r0             ,
    input   [3:0]          io_b_r1             ,
    input   [3:0]          io_b_de             ,
    
    input   [3:0]          i2c_a_c0            ,
    input   [3:0]          i2c_a_c1            ,
    input   [3:0]          i2c_a_r0            ,
    input   [3:0]          i2c_a_r1            ,
    input   [3:0]          i2c_a_de            ,
    input   [3:0]          i2c_b_c0            ,
    input   [3:0]          i2c_b_c1            ,
    input   [3:0]          i2c_b_r0            ,
    input   [3:0]          i2c_b_r1            ,
    input   [3:0]          i2c_b_de            ,

    output  [3:0]          a_c0                ,
    output  [3:0]          a_c1                ,
    output  [3:0]          a_r0                ,
    output  [3:0]          a_r1                ,
    output  [3:0]          a_de                ,
    output  [3:0]          b_c0                ,
    output  [3:0]          b_c1                ,
    output  [3:0]          b_r0                ,
    output  [3:0]          b_r1                ,
    output  [3:0]          b_de                

);




assign     a_c0  = (sel == 1'b1)? i2c_a_c0 : io_a_c0;
assign     a_c1  = (sel == 1'b1)? i2c_a_c1 : io_a_c1;
assign     a_r0  = (sel == 1'b1)? i2c_a_r0 : io_a_r0;
assign     a_r1  = (sel == 1'b1)? i2c_a_r1 : io_a_r1;
assign     a_de  = (sel == 1'b1)? i2c_a_de : io_a_de;
assign     b_c0  = (sel == 1'b1)? i2c_b_c0 : io_b_c0;
assign     b_c1  = (sel == 1'b1)? i2c_b_c1 : io_b_c1;
assign     b_r0  = (sel == 1'b1)? i2c_b_r0 : io_b_r0;
assign     b_r1  = (sel == 1'b1)? i2c_b_r1 : io_b_r1;
assign     b_de  = (sel == 1'b1)? i2c_b_de : io_b_de;







endmodule
