// Detect CM ACTIVE

module cm_active (
	input clk_div6,
	input rstn,
	input powerdown,
	input lfps1,
	input lfps2,
	input clear,
	output cm_active
	);

//`define SIMANA

reg lfps1_det;
reg lfps2_det;

reg [21:0] cnt;

`ifdef SIMANA
assign cm_active = (cnt >= 2000) && (lfps1_det ^ lfps2_det); //200us = 100ns * 10 * 200
`else
assign cm_active = (cnt >= 3600000) && (lfps1_det ^ lfps2_det); // 360ms = 100ns * 10000 * 360
`endif

always @(posedge clk_div6 or negedge rstn)
	if (!rstn)
		lfps1_det <= 1'b0;
	else if (powerdown)
		lfps1_det <= 1'b0;
	else if (clear)
		lfps1_det <= 1'b0;
	else if (lfps1)
		lfps1_det <= 1'b1;

always @(posedge clk_div6 or negedge rstn)
        if (!rstn)
                lfps2_det <= 1'b0;
        else if (powerdown)
                lfps2_det <= 1'b0;
        else if (clear)
                lfps2_det <= 1'b0;
        else if (lfps2)
                lfps2_det <= 1'b1;

always @(posedge clk_div6 or negedge rstn)
        if (!rstn)
		cnt <= 0;
        else if (powerdown)
                cnt <= 0;
	else if (clear)
		cnt <= 0;
`ifdef SIMANA
        else if ( (lfps1_det | lfps2_det) && cnt < 2100)
`else
	else if ( (lfps1_det | lfps2_det) && cnt < 3620000)
`endif
		cnt <= cnt + 1;

endmodule


