// Debounce lfps 100us

module lfps_debounce (
	input clk_div6,
	input rstn,
	input lfps_debounce_en,	
	input lfps_in,
	output lfps_out
	);

reg lfps_dl;
reg lfps_deb;
reg [3:0] lfps_cnt;
//reg [4:0] lfps_cnt;
parameter T_200US = 31; // 6.4us * 31.25

always @(posedge clk_div6 or negedge rstn)
        if (!rstn)
		lfps_dl <= 1'b0;
	else
		lfps_dl <= lfps_in;

always @(posedge clk_div6 or negedge rstn)
	if (!rstn)
		lfps_cnt <= 4'h0;
	else if (lfps_dl != lfps_in)
		lfps_cnt <= 4'h0;
	else if (lfps_cnt <= T_200US)
		lfps_cnt <= lfps_cnt + 4'h1;

always @(posedge clk_div6 or negedge rstn)
        if (!rstn)
		lfps_deb <= 1'b0;
	else if (lfps_cnt == T_200US - 1)
		lfps_deb <= lfps_in;

assign lfps_out = lfps_debounce_en ? lfps_deb : lfps_in;

endmodule

