// Power state

module power_st_1(
	input clk,
	input clk_div4,
	input rst_sel,
	input u2_en,
	input sel_350_450,
	input sel_4ms,
	input in_cnt_353ms_pulse,
	output out_cnt_353ms_pulse,
	output reg pulse_350450_syn,
	input rstn,
	input en,
	input d240ms_disable,
        input nolfps_4ms_en,
	input data_env_out_sync,
	input SLP_S0,

	output reg nolfps_4ms_r_n  ,
	input  o_nolfps_4ms_r_n,
	//input other_4ms,
        output out_nolfps_4ms_pulse,

	input [1:0] i2c_u2_period,

	// input signals from analog
	input lfps_det,
	input lfps_anotherchannel,
	input lfps_u2debounce,

	input RTERM_DETB,

	input txterm_det,
	input txterm_det_other,
	input hs_det,
	input hs_det_1,
	input elec_idle,
	input u2_nocmpdet,
	input u2_nocmpdet_other,

	input [21:0] tout_cnt_other,

	// output to analog
	output reg hs_open,
	output reg lfps_wait,
	output reg [1:0] power_mode,
	output reg [21:0] tout_cnt,
	output reg lp_tout,
	//output cma_note,
	output reg txdet_open,
	output reg [3:0] curr_state,
	output reg rxterm_open
  );

parameter ST_IDLE=4'b0000;
parameter ST_TXDET=4'b0001;
parameter ST_LFPS=4'b0011;
parameter ST_LFPSB=4'b0100;
parameter ST_U0=4'b1000;
parameter ST_U1=4'b1100;
parameter ST_U2=4'b1101;

//`define SIMANA


reg en_cnt;

//reg [3:0] curr_state,next_state;
reg [3:0] next_state;
wire [3:0] next_state1;

reg dl_lfps_det;
reg [31:0] lfpspolling_cnt;

reg u_T2,u_T2_o;
wire u_lT240;
wire u_nt240;
wire u_TMax;
wire u_T360,u_T360_o;
wire u_T300,u_T310,u_nT240;
wire u_T50;


//reg  nolfps_4ms_r_n;
wire state_u0;
wire cnt_4ms_pulse;
wire cnt_353ms_pulse;
wire cnt_449ms_pulse;
wire nolfps_4ms_rstn;
wire nolfps_4ms_pulse;
wire lfpspolling_rstn;
reg  nolfps_4ms_pulse_r;
reg [1:0] u2_nocmpdet_any_r;
wire nolfps_4ms_rstn_s;

wire u2_nocmpdet_any;

wire elec_idle_f;
reg chg_state; // check if state changed

reg  elec_idle_r;
reg  chg_state_r;

//reg  u2_en_r;

wire clk_n;


assign clk_n = clk;

assign out_nolfps_4ms_pulse = nolfps_4ms_pulse;

always @(posedge clk_n or negedge rstn)
begin
	if(!rstn)  elec_idle_r <= 0;
	else       elec_idle_r <= ~((~elec_idle) & nolfps_4ms_en);
end


always @(posedge clk_n or negedge rstn)
begin
	if(!rstn)  chg_state_r <= 0;
	else       chg_state_r <= chg_state;
end

always @(posedge clk or negedge rstn)
begin
	if(!rstn)  lfpspolling_cnt[18] <= 0;
	else       lfpspolling_cnt[18] <= ~o_nolfps_4ms_r_n;
end





//assign elec_idle_f = ~((~elec_idle) & (nolfps_4ms_en | rst_sel));


assign elec_idle_f = elec_idle & (~((~o_nolfps_4ms_r_n) & (~lfpspolling_cnt[18])));//u2_en_r));

`ifdef SIMANA
assign u_T50 = tout_cnt >= 22'd500; // 50us = 100ns *500
assign u_T300 = tout_cnt >= 22'd1_800; // 30us = 100ns * 300
assign u_T360 = tout_cnt >= 22'd2_160;
assign u_T360_o = tout_cnt_other >= 22'd2_160;
assign u_T310 = tout_cnt >= 22'd1_860;

assign u_TMax = tout_cnt <  22'd13_300; // 

//assign u_lT240 = lfpspolling_cnt < 32'd1_440 && lfpspolling_cnt >= 1; // 30us = 100ns * 10000 * 240
//assign u_nT240 = lfpspolling_cnt >= 32'd1_440;
//
assign u_lT240 = lfpspolling_cnt < 32'd30 && lfpspolling_cnt >= 1; // 30us = 100ns * 10000 * 240
assign u_nT240 = lfpspolling_cnt >= 32'd30;

`else
assign u_T50 = tout_cnt >= 22'd500_000; // 50ms 
assign u_T300 = tout_cnt >= 22'd3_000_000; // 300ms = 100ns * 10000 * 300
assign u_T360 = tout_cnt >= 22'd3_600_000;
assign u_T360_o = tout_cnt_other >= 22'd3_600_000;
assign u_T310 = tout_cnt >= 22'd3_100_000;

assign u_TMax = tout_cnt <  22'd4_000_000;

assign u_lT240 = lfpspolling_cnt < 32'd2_400_000 && lfpspolling_cnt >= 1; // 240ms = 100ns * 10000 * 240
assign u_nT240 = lfpspolling_cnt >= 32'd2_400_000;
`endif



`ifdef SIMANA
always @(*)
        case (i2c_u2_period)
                2'b11: u_T2 = tout_cnt >= 100; // 30us = 100ns * 300
                2'b01: u_T2 = tout_cnt >= 90; // 
                2'b10: u_T2 = tout_cnt >= 80; // 
                default: u_T2 = tout_cnt >= 70; // 
        endcase

always @(*)
        case (i2c_u2_period)
                2'b11: u_T2_o = tout_cnt_other >= 100; // 30us = 100ns * 300
                2'b01: u_T2_o = tout_cnt_other >= 90; // 
                2'b10: u_T2_o = tout_cnt_other >= 80; // 
                default: u_T2_o = tout_cnt_other >= 70; // 30us = 100ns * 300 
        endcase
`else
always @(*)
	case (i2c_u2_period)
		2'b11: u_T2 = tout_cnt >= 3_000_000; // 300ms = 100ns * 10000 * 30
		2'b01: u_T2 = tout_cnt >= 1_000_000; // 100ms = 100ns * 10000 * 100
		2'b10: u_T2 = tout_cnt >= 2_000_000; // 200ms 
		default: u_T2 = tout_cnt >= 500_000; // 50ms = 100ns * 10000 * 50
	endcase

always @(*)
        case (i2c_u2_period)
                2'b11: u_T2_o = tout_cnt_other >= 3_000_000; // 300ms = 100ns * 10000 * 30
                2'b01: u_T2_o = tout_cnt_other >= 1_000_000; // 100ms = 100ns * 10000 * 100
                2'b10: u_T2_o = tout_cnt_other >= 2_000_000; // 200ms 
                default: u_T2_o = tout_cnt_other >= 500_000; // 50ms = 100ns * 10000 * 50
        endcase
`endif

always @(posedge clk or negedge rstn)
	if (!rstn)
		curr_state <= ST_IDLE;
	else if (!en)  // Any cases reset to IDEL?
		curr_state <= ST_IDLE;
	else
		curr_state <= next_state1;

//4ms eco
//

//assign nolfps_4ms_rstn_s = nolfps_4ms_rstn_r[0] & nolfps_4ms_rstn;

assign state_u0 = ~(curr_state[0] | curr_state[2]);
`ifdef SIMANA
    assign cnt_4ms_pulse = tout_cnt[1] & tout_cnt[0] & (~(curr_state[0] | curr_state[2]));
    assign cnt_353ms_pulse = tout_cnt[4] & tout_cnt[0] & tout_cnt[3] & (~sel_350_450);
    assign cnt_499ms_pulse = tout_cnt[5] & tout_cnt[1] & tout_cnt[4] & sel_350_450;
`else
    assign cnt_4ms_pulse = tout_cnt[15] & tout_cnt[13] & (~(curr_state[0] | curr_state[2]));
    assign cnt_353ms_pulse = tout_cnt[13] & tout_cnt[17] & tout_cnt[16] & tout_cnt[14] & (~sel_350_450);
    assign cnt_499ms_pulse = tout_cnt[9] & tout_cnt[11] & tout_cnt[18] & tout_cnt[14] & sel_350_450;
`endif


assign out_cnt_353ms_pulse = (cnt_353ms_pulse | cnt_499ms_pulse)  & (~nolfps_4ms_en);

always @(posedge clk or negedge rstn)
begin
	if(!rstn) pulse_350450_syn <= 0;
	else      pulse_350450_syn <= cnt_353ms_pulse | cnt_499ms_pulse;
end

assign u2_nocmpdet_any = u2_nocmpdet | u2_nocmpdet_other;
assign nolfps_4ms_rstn = rstn & (~(lfps_det | lfps_anotherchannel)) & (~data_env_out_sync) & (~(u2_nocmpdet_any_r[1] | u2_nocmpdet_any_r[0] | u2_nocmpdet_any));
assign nolfps_4ms_pulse = nolfps_4ms_en & cnt_4ms_pulse;   //nolfps_4ms_en & state_u0 & cnt_4ms_pulse;

always @(posedge clk or negedge rstn)
	if (!rstn)
		u2_nocmpdet_any_r <= 2'b00;
	else
		u2_nocmpdet_any_r <= {u2_nocmpdet_any_r[0],u2_nocmpdet_any};




always @(posedge clk or negedge rstn)
	if (!rstn)
		nolfps_4ms_pulse_r <= 1'b0;
	else
		nolfps_4ms_pulse_r <= nolfps_4ms_pulse | in_cnt_353ms_pulse;


/*
always @(posedge nolfps_4ms_pulse_r or negedge nolfps_4ms_rstn)
begin
    if(!nolfps_4ms_rstn)
        nolfps_4ms_r_n <= 1'b1;//sel_4ms;
    else
        nolfps_4ms_r_n <= 0;
end
*/


assign nolfps_4ms_r_n = 0;



/*
reg nolfps_4ms_r_n_tmp;
always @(posedge nolfps_4ms_pulse_r)
  nolfps_4ms_r_n_tmp <= 1'b0;

assign nolfps_4ms_r_n = ~nolfps_4ms_rstn ? sel_4ms : nolfps_4ms_r_n_tmp;
*/   




assign next_state1[3] = next_state[3];
assign next_state1[1] = next_state[1];
assign next_state1[0] = next_state[0] | (~(nolfps_4ms_r_n | o_nolfps_4ms_r_n));
assign next_state1[2] = next_state[2] | (~(nolfps_4ms_r_n | o_nolfps_4ms_r_n));

//end





// State transfer
always @(*)
	case (curr_state)
	ST_IDLE: begin
		if (en)
			next_state = ST_TXDET;
		else
			next_state = ST_IDLE;
	end
	ST_TXDET: begin
		if (!SLP_S0)
			next_state = ST_LFPSB;
		else if (( txterm_det & txterm_det_other))
			next_state = ST_LFPS;
		else
			next_state = ST_TXDET;
	end
	ST_LFPSB: begin
		if (SLP_S0)
			next_state = ST_TXDET;
                else if (u_T50)
                        next_state = ST_U2;
                else if (lfps_det | lfps_anotherchannel )
                        next_state = ST_U0;
                else
                        next_state = ST_LFPSB;
        end
	ST_LFPS: begin
                if (!SLP_S0)
                        next_state = ST_LFPSB;
		else if (u_T50)
                        next_state = ST_U2;
		else if (lfps_det | lfps_anotherchannel )
			next_state = ST_U0;
		else
			next_state = ST_LFPS;
	end
	ST_U0: begin
		if (lfps_det | lfps_anotherchannel)
                        next_state = ST_U0;
		else if (u_T2 & u_T2_o)
			next_state = ST_U2;
		else
			next_state = ST_U0;
	end
	ST_U2: begin
		if (u2_nocmpdet | u2_nocmpdet_other)
			next_state = ST_IDLE;
		//else if (u_T360 & u_T360_o)
		//	next_state = ST_IDLE;
		else if (lfps_u2debounce | hs_det | lfps_det)     // Return to U0 if detect LFPS, when quit to idle?
			next_state = ST_U0;
		else
			next_state = ST_U2;
	end
		default: next_state = ST_IDLE;
	endcase

// Output control
always @(*)
	case (curr_state)
		ST_IDLE	: begin
			en_cnt	=	0;
			hs_open	=	0;
			power_mode	=	2'b00;
			txdet_open	=	0;
			rxterm_open	=	0;
			lfps_wait	=	0;
		end
		ST_TXDET: begin
			en_cnt	=	0;
			hs_open	=	0;
			power_mode	=	2'b00;
			txdet_open	=	1;
			rxterm_open	=	0;
			lfps_wait	=	0;
		end
		ST_LFPS:	begin
			en_cnt	=	1;
			hs_open	=	0;
			power_mode	=	2'b00;
			txdet_open	=	0;
			rxterm_open	=	1;
			lfps_wait	=	1;
		end
		ST_U0: begin
			en_cnt	=	1;
			hs_open	=	1;
			power_mode	=	2'b01;
			txdet_open	=	0;
			rxterm_open	=	1;
			lfps_wait	=	0;
		end
		ST_U1: begin
			en_cnt	=	1;
			hs_open	=	0;
			power_mode	=	2'b10;
			txdet_open	=	0;
			rxterm_open	=	1;
			lfps_wait	=	0;
		end
		ST_U2: begin
			en_cnt	=	1;
			hs_open	=	0;
			power_mode	=	2'b11;
			txdet_open	=	0;
			rxterm_open	=	1;
			lfps_wait	=	0;
		end
		default: begin
			en_cnt	=	0;
			hs_open	=	0;
			power_mode	=	2'b00;
			txdet_open	=	0;
			rxterm_open	=	0;
			lfps_wait	=	0;
		end
 endcase

// Check if state changed
always @(posedge clk or negedge rstn)
	if (!rstn)
		chg_state <= 0;
	else if (next_state != curr_state)
		chg_state <= 1;
	else
		chg_state <= 0;

// Time out counter
//
wire tout_cnt_rstn;

assign tout_cnt_rstn = rstn & ((elec_idle_f & (~chg_state_r)) | rst_sel) ;

//assign tout_cnt_rstn = rstn & elec_idle_f & (~chg_state);

always @(posedge clk or negedge rstn)
	if (!rstn)
  		tout_cnt <= 0;
	else if (!en | chg_state | !elec_idle_f | u_lT240)
		tout_cnt <= 0;
	else if (en_cnt && u_TMax)
		tout_cnt <= tout_cnt + 1;

always @(posedge clk or negedge rstn)
        if (!rstn)
		lp_tout <= 1;
	else
		lp_tout <= u_T310 && (power_mode == 2'b11);

//assign cma_note = u_T360 ;
always @(posedge clk or negedge rstn)
        if (!rstn)
		dl_lfps_det <= 0;
	else
		dl_lfps_det <= lfps_det;

assign lfpspolling_rstn = rstn & (~d240ms_disable);

always @(posedge clk or negedge lfpspolling_rstn)
        if (!lfpspolling_rstn)
		{lfpspolling_cnt[31:19], lfpspolling_cnt[17:0]}<= 0;
	else 
		{lfpspolling_cnt[31:19], lfpspolling_cnt[17:0]}<= 0;
	/*
	else if (!en | lfps_det | !rxterm_open | hs_det)
		lfpspolling_cnt <= 0;
	else if (dl_lfps_det & !lfps_det)
		lfpspolling_cnt <= 1;
	else if (u_nT240)
		lfpspolling_cnt <= lfpspolling_cnt;
	else if (lfpspolling_cnt != 0)
		lfpspolling_cnt <= lfpspolling_cnt + 1;
         */
endmodule

